/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ui.view.components;

//import controller.Controller;
import domain.Manufacturer;
import domain.MeasurementUnit;
import domain.Product;
import java.math.BigDecimal;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelProduct extends AbstractTableModel{
    boolean editable;
    List<Product> products;
    String[] columnNames=new String[]{"Šifra", "Naziv", "Opis", "Proizvođač", "Jedinica mere", "Cena"};

    public TableModelProduct(List<Product> products) {
        //products=Controller.getInstance().getAllProducts();
        this.products=products;
    }

    public void setEditable(boolean editable) {
        this.editable = editable;
    }
    
    
    
    @Override
    public int getRowCount() {
        return products.size();
    }

    @Override
    public int getColumnCount() {
        //return 6;
        return columnNames.length;
    }

    @Override
    public String getColumnName(int i) {
        return columnNames[i];
    }

    @Override
    public boolean isCellEditable(int x, int y) {
        if(!editable){
            return false;
        }
        return y==1 || y==2 || y==3 || y==4 || y==5;
    }
    
    
    
    

    @Override
    public Object getValueAt(int x, int y) {
        Product product=products.get(x);
        switch(y){
            case 0: return product.getId();
            case 1: return product.getName();
            case 2: return product.getDescription();
            case 3: return product.getManufacturer();
            case 4: return product.getMeasurementUnit();
            case 5: return product.getPrice();
            default: return "n/a";
        }
    }

    @Override
    public void setValueAt(Object value, int x, int y) {
        Product product=products.get(x);
        switch(y){
            case 0: product.setId(new Long(value.toString())); break;
            case 1: product.setName(value.toString()); break;
            case 2: product.setDescription(value.toString()); break;
            case 3: product.setManufacturer((Manufacturer)value); break;
            case 4: product.setMeasurementUnit((MeasurementUnit)value); break;
            case 5: product.setPrice(new BigDecimal(value.toString())); break;
        }
    }
    
    public Product getProductAt(int rowIndex){
        return products.get(rowIndex);
    }
    
}
